import {
  ProtocolResponse,
  ProtocolDecoder,
  ProtocolMessage,
  BodyStringDivider
} from '@ucap-webmessenger/protocol';
import { StatusCode } from '@ucap-webmessenger/core';
import { StatusInfo } from './status';

export interface BuddyResponse extends ProtocolResponse {
  // {상태정보}...
  statusInfos: StatusInfo[];
}

export const decodeBuddy: ProtocolDecoder<BuddyResponse> = (
  message: ProtocolMessage
) => {
  const statusInfos: StatusInfo[] = [];
  message.bodyList.forEach(statusInfo => {
    const info = statusInfo.split(BodyStringDivider);
    let idx = 0;
    statusInfos.push({
      userSeq: info[idx],
      pcStatus: info[idx++] as StatusCode,
      phoneStatus: info[idx++] as StatusCode,
      mobileStatus: info[idx++] as StatusCode,
      conferenceStatus: info[idx++] as StatusCode,
      statusMessage: info[idx++],
      mobileConferenceStatus: info[idx++] as StatusCode,
      imessengerStatus: info[idx++] as StatusCode
    });
  });
  return {
    statusInfos
  } as BuddyResponse;
};
